/* Generated by CIL v. 1.3.6 */
/* print_CIL_Input is false */

int cpt  = 3;
/*@ global invariant inv_cpt: ((0 <= cpt) && (cpt <= 3));
 */
int status  = 0;
/*@ global invariant inv_status: ((0 <= status) && (status <= 1));

*/
//****************
//* BEGIN Primitives generated for LTL verification
//* 
//* States and Trans Variables
int buch_CurStates[2]  = {0, 1};
int buch_CurTrans[4]  = {0, 1, 0, 0};
int buch_CurStates_old[2]  = {1, 0};
//* 
//* Their invariants
/*@
global
invariant Buch_Ranges_Validity:
                               (\valid(buch_CurTrans + (0 .. 3)) &&
                               (\valid(buch_CurStates + (0 .. 1)) &&
                               \valid(buch_CurStates_old + (0 .. 1))));

*/
//* 
//* 
//* Some constants
enum buch_ListOper {
    op_main = 0,
    op_init_trans = 1,
    op_commit_trans = 2
} ;
enum buch_ListOper buch_CurOperation  = op_main;
enum Buch_OpStatusList {
    buch_Called = 0,
    buch_Terminated = 1
} ;
enum Buch_OpStatusList buch_CurOpStatus  = buch_Called;
//* 
//* Loops management
int buch_Loop_Init_23  = 0;
//* 
//**************** 
//* Axiomatized transitions automata
/*@
axiomatic
  buch_Trans_Start {
  logic integer buch_Trans_Start(integer tr) ;
  
  axiom buch_Trans_Start0: (buch_Trans_Start(0) == 0);
  
  axiom buch_Trans_Start1: (buch_Trans_Start(1) == 0);
  
  axiom buch_Trans_Start2: (buch_Trans_Start(2) == 1);
  
  axiom buch_Trans_Start3: (buch_Trans_Start(3) == 1);
  
  }
 */
/*@
axiomatic
  buch_Trans_Stop {
  logic integer buch_Trans_Stop(integer tr) ;
  
  axiom buch_Trans_Stop0: (buch_Trans_Stop(0) == 0);
  
  axiom buch_Trans_Stop1: (buch_Trans_Stop(1) == 1);
  
  axiom buch_Trans_Stop2: (buch_Trans_Stop(2) == 0);
  
  axiom buch_Trans_Stop3: (buch_Trans_Stop(3) == 1);
  
  }
 */
/*@
predicate buch_Trans_Cond_param{L}(integer _buch_numTrans, integer _buch_op,
                                  integer _buch_status) =
  (((_buch_numTrans == 0) ==>
   ((status != 0) &&
   ((_buch_op == op_init_trans) && (_buch_status == buch_Terminated))))
  &&
  (((_buch_numTrans == 1) ==> \true) &&
  (((_buch_numTrans == 2) ==>
   ((status != 0) &&
   (((_buch_op == op_init_trans) && (_buch_status == buch_Terminated)) &&
   !(((_buch_op == op_commit_trans) && (_buch_status == buch_Called))))))
  &&
  ((_buch_numTrans == 3) ==>
  !(((_buch_op == op_commit_trans) && (_buch_status == buch_Called)))))));
 */
/*@
predicate buch_Trans_Cond{L}(integer _buch_numTrans) =
  buch_Trans_Cond_param{L}(_buch_numTrans, buch_CurOperation,
                          buch_CurOpStatus);

*/
//* 
//**************** 
//* Safety invariants
//* 
//* Inv 1 : Each active state is reachable
/*@
global
invariant _Buch_st_reach_1:
                           (\forall integer _buch_st;
                           ((((0 <= _buch_st) && (_buch_st < 2)) &&
                            (\forall integer _buch_tr;
                            (((0 <= _buch_tr) && (_buch_tr < 4)) ==>
                            ((buch_CurTrans[_buch_tr] == 0) ||
                            ((buch_Trans_Stop(_buch_tr) != _buch_st) ||
                            (!(buch_Trans_Cond(_buch_tr)) ||
                            (buch_CurStates_old[buch_Trans_Start(_buch_tr)] ==
                            0)))))))
                           ==> (buch_CurStates[_buch_st] == 0)));
 */
//* Inv 2 : Each non-active state is not reachable
/*@
global
invariant _Buch_st_reach_2:
                           (\forall integer _buch_st;
                           ((((0 <= _buch_st) && (_buch_st < 2)) &&
                            (buch_CurStates[_buch_st] == 0))
                           ==>
                           (\forall integer _buch_tr;
                           (((0 <= _buch_tr) && (_buch_tr < 4)) ==>
                           ((buch_CurTrans[_buch_tr] == 0) ||
                           ((buch_Trans_Stop(_buch_tr) != _buch_st) ||
                           (!(buch_Trans_Cond(_buch_tr)) ||
                           (buch_CurStates_old[buch_Trans_Start(_buch_tr)] ==
                           0))))))));
 */
//* Inv 3 : Each active state is reachable
/*@
global
invariant _Buch_st_reach_3:
                           (\forall integer _buch_st;
                           ((((0 <= _buch_st) && (_buch_st < 2)) &&
                            (buch_CurStates[_buch_st] != 0))
                           ==>
                           (\exists integer _buch_tr;
                           (((0 <= _buch_tr) && (_buch_tr < 4)) &&
                           ((buch_CurTrans[_buch_tr] != 0) &&
                           (buch_Trans_Cond(_buch_tr) &&
                           ((buch_Trans_Stop(_buch_tr) == _buch_st) &&
                           (buch_CurStates_old[buch_Trans_Start(_buch_tr)] !=
                           0))))))));
 */
//* Inv 4 : Each transition annotated as crossable is crossable
/*@
global
invariant _Buch_tr_cross_1:
                           (\forall integer _buch_tr;
                           ((((0 <= _buch_tr) && (_buch_tr < 4)) &&
                            (buch_CurTrans[_buch_tr] != 0))
                           ==>
                           (buch_Trans_Cond(_buch_tr) &&
                           ((buch_CurStates_old[buch_Trans_Start(_buch_tr)] !=
                            0)
                           &&
                           (buch_CurStates[buch_Trans_Stop(_buch_tr)] != 0)))));
 */
//* Inv 5 : Each crossable transition is crossed
/*@
global
invariant _Buch_tr_cross_2:
                           (\forall integer _buch_tr;
                           ((((0 <= _buch_tr) && (_buch_tr < 4)) &&
                            ((buch_CurStates_old[buch_Trans_Start(_buch_tr)]
                             != 0)
                            && buch_Trans_Cond(_buch_tr)))
                           ==>
                           ((buch_CurTrans[_buch_tr] != 0) &&
                           (buch_CurStates[buch_Trans_Stop(_buch_tr)] != 0))));
 */
//* Inv 6 : Non-crossable transitions are not crossed over
/*@
global
invariant _Buch_tr_cross_3:
                           (\forall integer _buch_tr;
                           ((((0 <= _buch_tr) && (_buch_tr < 4)) &&
                            ((buch_CurStates_old[buch_Trans_Start(_buch_tr)]
                             != 0)
                            || !(buch_Trans_Cond(_buch_tr))))
                           ==> (buch_CurTrans[_buch_tr] != 0)));

*/
//* 
//* END Primitives generated for LTL verification
//****************
/*@ requires (((0 == buch_CurTrans[0]) && (0 == buch_CurTrans[2])) &&
             (0 == buch_CurTrans[3]));
    requires (0 != buch_CurTrans[1]);
    requires (0 == buch_CurStates[0]);
    requires (0 != buch_CurStates[1]);
    requires \true;
    behavior Buchi_property_behavior_1:
      assumes (0 != buch_CurStates[1]);
      ensures (((0 == buch_CurTrans[0]) && (0 == buch_CurTrans[1])) &&
              (0 == buch_CurTrans[2]));
      ensures (0 != buch_CurTrans[3]);
      ensures (0 == buch_CurStates[0]);
      ensures (0 != buch_CurStates[1]);
      
    behavior a:
      ensures ((0 <= \result) && (\result <= 1));
      */
int commit_trans(void) 
{ int __retres ;
  
  {__retres = 1;
  {buch_CurOperation = op_commit_trans;
  buch_CurOpStatus = buch_Terminated;
  buch_CurStates_old[0] = buch_CurStates[0];
  buch_CurStates_old[1] = buch_CurStates[1];
  buch_CurStates[0] = 0;
  buch_CurStates[1] = buch_CurStates_old[1] || buch_CurStates_old[0];
  buch_CurTrans[0] = 0;
  buch_CurTrans[1] = buch_CurStates_old[0];
  buch_CurTrans[2] = 0;
  buch_CurTrans[3] = buch_CurStates_old[1];
  return (__retres);}
  }

}
/*@ requires ((0 == buch_CurTrans[0]) && (0 == buch_CurTrans[2]));
    requires ((0 != buch_CurTrans[1]) || (0 != buch_CurTrans[3]));
    requires (0 == buch_CurStates[0]);
    requires (0 != buch_CurStates[1]);
    requires \true;
    behavior Buchi_property_behavior_1:
      assumes (0 != buch_CurStates[1]);
      ensures ((0 == buch_CurTrans[0]) && (0 == buch_CurTrans[1]));
      ensures ((0 != buch_CurTrans[2]) || (0 != buch_CurTrans[3]));
      ensures \true;
      ensures ((0 != buch_CurStates[0]) || (0 != buch_CurStates[1]));
      
    behavior a:
      ensures ((0 <= \result) && (\result <= 1));
      */
int init_trans(void) 
{ int __retres ;
  
  {__retres = 1;
  {buch_CurOperation = op_init_trans;
  buch_CurOpStatus = buch_Terminated;
  buch_CurStates_old[0] = buch_CurStates[0];
  buch_CurStates_old[1] = buch_CurStates[1];
  buch_CurStates[0] = (status && buch_CurStates_old[1]) || (status && buch_CurStates_old[0]);
  buch_CurStates[1] = buch_CurStates_old[1] || buch_CurStates_old[0];
  buch_CurTrans[0] = status && buch_CurStates_old[0];
  buch_CurTrans[1] = buch_CurStates_old[0];
  buch_CurTrans[2] = status && buch_CurStates_old[1];
  buch_CurTrans[3] = buch_CurStates_old[1];
  return (__retres);}
  }

}
/*@ requires (((0 == buch_CurTrans[0]) && (0 == buch_CurTrans[2])) &&
             (0 == buch_CurTrans[3]));
    requires (0 != buch_CurTrans[1]);
    requires (0 == buch_CurStates[0]);
    requires (0 != buch_CurStates[1]);
    requires \true;
    behavior Buchi_property_behavior_1:
      assumes (0 != buch_CurStates[1]);
      ensures ((0 == buch_CurTrans[0]) && (0 == buch_CurTrans[2]));
      ensures ((0 != buch_CurTrans[1]) || (0 != buch_CurTrans[3]));
      ensures (0 == buch_CurStates[0]);
      ensures (0 != buch_CurStates[1]);
      
    behavior a:
      ensures ((0 <= \result) && (\result <= 1));
      */
int main(void) 
{ int tmp ;
  int __retres ;
  
  {{{/*@ ghost buch_Loop_Init_23 = 1; */
    
    /*@
        loop invariant
          (((0 != buch_CurStates[0]) || (0 != buch_CurStates[1])) &&
          (\true &&
          ((((0 != buch_CurTrans[1]) || (0 != buch_CurTrans[2])) ||
           (0 != buch_CurTrans[3]))
          && (0 == buch_CurTrans[0]))));
        
        loop invariant
          ((buch_Loop_Init_23 != 0) ==>
          ((buch_CurStates[0] == 0) &&
          ((buch_CurTrans[2] == 0) && (buch_CurTrans[3] == 0))));
        
        loop invariant ((buch_Loop_Init_23 == 0) ==> (buch_CurTrans[1] == 0));
        
        loop invariant
          (i:
           ((((0 <= status) && (status <= 1)) && ((0 <= cpt) && (cpt <= 3)))
           && ((cpt == 0) ==> (status == 0))));
        
         */
    while (1) {if (! (cpt > 0)) {goto while_0_break;}
      
      /*@ ghost buch_Loop_Init_23 = 0; */
      
      {buch_CurOperation = op_init_trans;
      buch_CurOpStatus = buch_Called;
      buch_CurStates_old[0] = buch_CurStates[0];
      buch_CurStates_old[1] = buch_CurStates[1];
      buch_CurStates[0] = 0;
      buch_CurStates[1] = buch_CurStates_old[1] || buch_CurStates_old[0];
      buch_CurTrans[0] = 0;
      buch_CurTrans[1] = buch_CurStates_old[0];
      buch_CurTrans[2] = 0;
      buch_CurTrans[3] = buch_CurStates_old[1];
      status = init_trans();}
      
      if (status) {{buch_CurOperation = op_commit_trans;
                   buch_CurOpStatus = buch_Called;
                   buch_CurStates_old[0] = buch_CurStates[0];
                   buch_CurStates_old[1] = buch_CurStates[1];
                   buch_CurStates[0] = 0;
                   buch_CurStates[1] = buch_CurStates_old[0];
                   buch_CurTrans[0] = 0;
                   buch_CurTrans[1] = buch_CurStates_old[0];
                   buch_CurTrans[2] = 0;
                   buch_CurTrans[3] = 0;
                   tmp = commit_trans();}
        
        if (tmp) {goto label_ok;}
        }
      
      cpt --;}
    }
   
   while_0_break: /* CIL Label */ ;}
  
  __retres = 0;
  goto return_label;
  label_ok: 
  __retres = 1;
  return_label: /* CIL Label */ 
  {buch_CurOperation = op_main;
  buch_CurOpStatus = buch_Terminated;
  buch_CurStates_old[0] = buch_CurStates[0];
  buch_CurStates_old[1] = buch_CurStates[1];
  buch_CurStates[0] = 0;
  buch_CurStates[1] = buch_CurStates_old[1] || buch_CurStates_old[0];
  buch_CurTrans[0] = 0;
  buch_CurTrans[1] = buch_CurStates_old[0];
  buch_CurTrans[2] = 0;
  buch_CurTrans[3] = buch_CurStates_old[1];
  return (__retres);}
  }

}
